% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3-blob.R
\name{opts_blob}
\alias{opts_blob}
\title{Constructive options for class 'blob'}
\usage{
opts_blob(constructor = c("blob", "next"), ...)
}
\arguments{
\item{constructor}{String. Name of the function used to construct the object.}

\item{...}{Additional options used by user defined constructors through the \code{opts} object}
}
\value{
An object of class <constructive_options/constructive_options_blob>
}
\description{
These options will be used on objects of class 'blob'.
}
\details{
Depending on \code{constructor}, we construct the object as follows:
\itemize{
\item \code{"blob"} (default): Use \code{blob::blob()} on a raw object.
\itemize{
\item \code{"new_blob"} (default): Use \code{blob::new_blob()} on a list of raw objects.
}
\item \code{"as.blob"} : Use \code{blob::as_blob()} on a character vector
}

Use \code{opts_raw()} and \code{opts_character()} to tweak the construction of raw or
character objects constructed as part of the blob construction.
}
