% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3-dots.R
\name{opts_dots}
\alias{opts_dots}
\title{Constructive options for type '...'}
\usage{
opts_dots(constructor = c("default"), ...)
}
\arguments{
\item{constructor}{String. Name of the function used to construct the object.}

\item{...}{Additional options used by user defined constructors through the \code{opts} object}
}
\value{
An object of class <constructive_options/constructive_options_dots>
}
\description{
These options will be used on objects of type '...'. These are rarely encountered
in practice. By default this function is useless as nothing can be set, this
is provided in case users want to extend the method with other constructors.
}
\details{
Depending on \code{constructor}, we construct the object as follows:
\itemize{
\item \code{"default"} : We use the construct \verb{(function(...) get(\\"...\\"))(a = x, y)}
which we evaluate in the correct environment.
}
}
