% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3-ggplot2-ggplot.R
\name{opts_ggplot}
\alias{opts_ggplot}
\title{Constructive options for class 'ggplot'}
\usage{
opts_ggplot(constructor = c("ggplot", "next", "list"), ...)
}
\arguments{
\item{constructor}{String. Name of the function used to construct the object, see Details section.}

\item{...}{Additional options used by user defined constructors through the \code{opts} object}
}
\value{
An object of class <constructive_options/constructive_options_ggplot>
}
\description{
These options will be used on objects of class 'ggplot'.
}
\details{
Depending on \code{constructor}, we construct the object as follows:
\itemize{
\item \code{"ggplot"} (default): Use \code{ggplot2::ggplot()}
\item \code{"next"} : Use the constructor for the next supported class. Call \code{.class2()}
on the object to see in which order the methods will be tried.
\item \code{"list"} : Use \code{list()} and treat the class as a regular attribute.
}
}
