% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/s3-matrix.R
\name{opts_matrix}
\alias{opts_matrix}
\title{Constructive options for matrices}
\usage{
opts_matrix(constructor = c("matrix", "array", "cbind", "rbind", "next"), ...)
}
\arguments{
\item{constructor}{String. Name of the function used to construct the object.}

\item{...}{Additional options used by user defined constructors through the \code{opts} object}
}
\value{
An object of class <constructive_options/constructive_options_matrix>
}
\description{
Matrices are atomic vectors, lists, or objects of type \code{"expression"} with a \code{"dim"}
attributes of length 2.
}
\details{
Depending on \code{constructor}, we construct the object as follows:
\itemize{
\item \code{"matrix"} : We use \code{matrix()}
\item \code{"array"} : We use \code{array()}
\item \code{"cbind"},\code{"rbind"} : We use \code{cbind()} or \code{"rbind()"}, this makes named
columns and rows easier to read.
\item \code{"next"} : Use the constructor for the next supported class. Call \code{.class2()}
on the object to see in which order the methods will be tried. This will usually
be equivalent to \code{"array"}
\item \code{"atomic"} : We define as an atomic vector and repair attributes
}
}
